<%-
  require 'date'
  require 'set'

  default_partition = nil
  default_account = `sacctmgr -n -P list user $USER format=DefaultAccount`
  reservations = Set.new
  accounts = {}
  partitions = {}
  gpus = {}

  # get partitions and gres
  sinfo_lines=`sinfo -h -o "%P|%G"`.split(/\n+/)
  for sinfo_line in sinfo_lines do
    partition, all_gres = sinfo_line.split('|')

    # check if this is default partition
    if partition.end_with?("*")
      partition = partition[0, partition.length()-1]
      default_partition = partition
    end

    # adding partition to partitions objects
    if !partitions.key?(partition)
        partitions[partition] = {
            'accounts' => Set.new,
            'reservations' => Set.new
        }
    end

    # collecting gpus from current partition
    gpus_list = Set.new
    for gres_item in all_gres.split(',')
      if gres_item != '(null)'
        gres_type, gres_name, gres_qty = gres_item.split(':')
        if gres_type == 'gpu'
          if !gpus.key?(gres_name)
              gpus[gres_name] = {
                  'partitions' => Set.new
              }
          end
          gpus[gres_name]['partitions'] << partition
        end
      end
    end
  end

  # get accounts and partitions associations
  sacctmgr_lines = `sacctmgr list -n -P associations user=$USER format=account%250,partition%250`.split(/\n+/)
  for sacctmgr_line in sacctmgr_lines
    account, partition = sacctmgr_line.split('|')
    if !accounts.key?(account)
      accounts[account] = {
          'reservations' => Set.new
      }
    end

    if partition == ''
        # this account has access to all partitions
        for partition in partitions.keys
          partitions[partition]['accounts'] << account
        end
    else
        partitions[partition]['accounts'] << account
    end
  end

  # get reservations
  scontrol_result = `scontrol show reservation -o`
  if !scontrol_result.include?("No reservations in the system")
    for reservation_line in scontrol_result.split(/\n+/)
      is_usable = false
      reservation = {}
      for reservation_part in reservation_line.split(' ')
        parts = reservation_part.split('=')
        if parts.length == 2 and parts[1] != '(null)'
            reservation[parts[0]] = parts[1]
        else
            reservation[parts[0]] = nil
        end
      end

      if reservation['Accounts'] == nil
         # this reservation is available for all accounts
         reservation['Accounts'] = accounts.keys
         is_usable = true
      else
        reservation['Accounts'] = reservation['Accounts'].split(',')
        reservation_accounts = reservation['Accounts'].split(',')
        is_usable = reservation['Accounts'].intersection(accounts.keys).length > 0
      end

      if reservation['PartitionName'] != nil
        # we need to check if we have at least one account which has access to this partition
        for account in reservation['Accounts']
          if !partitions[reservation['PartitionName']]['accounts'].include?(account)
            reservation['Accounts'].delete(account)
          end
        end
        if reservation['Accounts'].length == 0
          is_usable = false
        end
      end

      if is_usable
        reservations << reservation['ReservationName']
        for account in reservation['Accounts']
          accounts[account]['reservations'] << reservation['ReservationName']
        end
        if reservation['PartitionName'] != nil
            partitions[reservation['PartitionName']]['reservations'] << reservation['ReservationName']
        else
            for partition in partitions.keys
                partitions[partition]['reservations'] << reservation['ReservationName']
            end
        end
      end
    end
  end
  #get versions
  versions=[]
  versions_result=`ls /shared/software/singularity/images/cryosparc-[0-9]*.sif |sed -e 's@/shared/software/singularity/images/cryosparc-\\(.*\\).sif@\\1@'`
  for version_line in versions_result.split(/\n+/)
    versions << version_line
  end
%>
---

cluster: "phantom"

attributes:
  license:
    widget: text_field
    required: true
    label: CryoSPARC license
    help: Request a free academic license on the <a href="https://cryosparc.com/download">CryoSPARC website</a>
  slurm_partition_master: igbmc
  slurm_account:
    widget: select
    label: Account
    required: true
    options:
      <% accounts.keys.each do |account| %>
      - ['<%= account %>',
         '<%= account %>',
         data-reservations: <%= accounts[account]['reservations'].to_a.join(" ") %>,
        ]
      <% end %>
    value: <%= default_account %>
  bc_num_slots: 1
  bc_num_hours:
    max: 192
    value: 8
    label: Server lifetime (in hours)
  slurm_partition_worker:
    widget: select
    cacheable: false
    label: SLURM partition used by CryoSPARC jobs
    required: true
    options:
      <% partitions.keys.each do |partition| %>
      - ['<%= partition %>',
         '<%= partition %>',
          data-accounts: "<%= partitions[partition]['accounts'].to_a.join(" ") %>",
          data-reservations: "<%= partitions[partition]['reservations'].to_a.join(" ") %>",
        ]
      <% end %>
    value: <%= default_partition %>
  gres_gpu:
    widget: select
    cacheable: false
    label: GPU model for CryoSPARC jobs
    help: If want to use GPUs make sure to choose a SLURM partition with GPU nodes available
    required: fale
    options:
      - ['Any GPU available', '']
      <% gpus.keys.each do |gpu| %>
      - ['<%= gpu %>',
         '<%= gpu %>',
          data-partitions: "<%= gpus[gpu]['partitions'].to_a.join(" ") %>",
        ]
      <% end %>
  version:
    widget: select
    label: Version
    required: true
    options:
      <% versions.each do |version| %>
      - ['<%= version %>',
         '<%= version %>',
        ]
      <% end %>

form:
  - license
  - bc_num_hours
  - bc_num_slots
  - slurm_account
  - slurm_partition_master
  - slurm_partition_worker
  - gres_gpu
  - version
